


/**
 * Title:        Observation.java
 * Description:  Class for observed points.
 * Copyright:    Annemari Auvinen, Anu Niemi (c) 2002
 * Company:
 * @author       Annemari Auvinen, Anu Niemi
 * @version      1.0
 *
 * @param   x        Double value of x
 * @param   y        Double value of y
 */

public class Observation {
  private double x;
  private double y;

/**
 * Constructor for the Observation.
 * @param   x   Double value of x
 * @param   y   Double value of y
 */
  public Observation(double x, double y) {
    this.x = x;
    this.y = y;
  }

/**
  * Sets the x.
  * @param    avalue    Double value of x
  */
 public void setX(double value)
  {
    x = value;
  }

/**
 * Returns the value of x
 * @return      Double value of x
 */
  public double getX()
  {
    return x;
  }

/**
  * Sets the y.
  * @param    avalue    Double value of y
  */
  public void setY(double value)
  {
    y = value;
  }

/**
 * Returns the value of y
 * @return      Double value of y
 */
  public double getY()
  {
    return y;
  }
}