import java.util.*;
import java.lang.*;
import java.lang.Math;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class kmeans {
//Data vectors
 // private Vector Xdata = new Vector();
 // private Vector Ydata = new Vector();

  private Vector data = new Vector();

  private Vector w = new Vector();
  private Vector newW = new Vector();

  private Vector classedData = new Vector();

  private int k;
  private double epsilon = 0.1;

  public void setEpsilon(double value)
  {
    epsilon = value;
  }

  public void setK(int value)
  {
    k = value;
  }

  public void setWVector(){
    int points = data.size();
    int ii;
    //! tarkasta ett k<points constructorissa

    Vector used = new Vector();
    Random random = new Random();

    Integer index = new Integer(0);

    for (int i = 0; i<k; i++)
    {
      //!tarkasta ett 0 ja points voi tulla mys
      do{
        ii = random.nextInt(points);
        index = new Integer(ii);
      }while(used.contains(index)); //ehto oikeinpin?

      used.add(index);
      w.add(data.elementAt(ii));
    }
  for (int i=0; i<k; i++)
  {
     havainto hav = (havainto)w.elementAt(i);
     hav.getX();
     //System.out.print(hav.getX());
  }
   }


  public void createDataVectors()
  {
    for (int i = 0; i<k; i++)
    {
      classedData.add(new Vector());
    }
  }


  public kmeans(Vector data, int k ) {
    this.data = data;
    this.k = k;
    setWVector();
    createDataVectors();
    classData();
    do {
      avarages();
      boolean end =testEnd();
      if (end)
      {
         break;
      }
      else {
        w = newW;
        classedData.removeAllElements();
        createDataVectors();
        classData();
      }
    } while (true);

  }

  public void classData()
  {
    //for perception
    double x;
    double y;

    double wx;
    double wy;

    double dist;
    int index = 0;

    for (int i=0; i<data.size(); i++)
    {
      dist = -1;
      havainto dataPoint = (havainto)data.elementAt(i);
      x = dataPoint.getX();
      y = dataPoint.getY();

      for (int j=0; j<k; j++)
      {
        havainto ww = (havainto)w.elementAt(j);
        wx = ww.getX();
        wy = ww.getY();
        double testDist;
        testDist = Math.sqrt( (Math.pow( (x-wx), 2.0) + Math.pow( (y-wy), 2.0) ) );

        if (dist < 0)
          {
            dist = testDist;
            index = j;
          }

        if (dist > testDist)
        {
          dist =testDist;
          index = j;
        }

      }

      Vector vector = (Vector)classedData.elementAt(index);
      vector.add(dataPoint);
    }

  }

  public void avarages()
  {
     double x = 0.0;
     double y = 0.0;

     for(int i=0; i<k; i++)
     {
       x = 0.0;
       y = 0.0;
       Vector classedPoints = (Vector)classedData.elementAt(i);
       int dataPoints = classedPoints.size();

       //X-value
       for (int j=0; j<dataPoints; j++)
       {
         havainto point = (havainto)classedPoints.elementAt(j);
         x = x + point.getX();
       }
       x = x / dataPoints;

       //y-value
       for (int j=0; j<dataPoints; j++)
       {
         havainto point = (havainto)classedPoints.elementAt(j);
         y = y + point.getY();
       }
       y = y / dataPoints;
      havainto h = new havainto(x,y);
      newW.add(h);
     }



  }

  public void testiPrint()
  {
   // Vector vector = (Vector)classedData.elementAt(0);
    //havainto h = (havainto)vector.elementAt(0);
    //System.out.print(h.getX());


    for (int i=0; i<k; i++)
    {
      Vector vector =(Vector)classedData.elementAt(i);
      for (int j=0; j<vector.size(); j++)
     {

       havainto h = (havainto)vector.elementAt(j);
       //System.out.print(h.getX());
       //System.out.print(h.getY());
     }
    System.out.println();
    }



  }

  public boolean testEnd()
  {
    for(int i = 0; i<k; i++ )
    {
       havainto newWvalue = (havainto)newW.elementAt(i);
       havainto oldWvalue = (havainto)w.elementAt(i);
       double testDist;
       testDist = Math.sqrt( (Math.pow( (oldWvalue.getX()-newWvalue.getX()), 2.0) + Math.pow( (oldWvalue.getY()- newWvalue.getY()), 2.0) ) );
       if (testDist > epsilon )
       {
         return false;
       }
    }
    return true;
  }

}