import java.util.*;
import java.lang.*;

/**
 * Title:        ArrangeVector.java
 * Description:  Class for arranging vector descending based by x-value.
 * Copyright:    Annemari Auvinen, Anu Niemi (c) 2002
 * Company:
 * @author       Annemari Auvinen, Anu Niemi
 * @version      1.0
 */

public class ArrangeVector {

/**
 * Constructor for the Observation.
 */
  public ArrangeVector() {
  }

/**
     * Returns vector, which includes the given vector sorted by descending order based on
     * value of x.
     *
     * @param   midpoints     Vector of midpoints.
     * @return                Vector of arranged midpoints
     */
  public Vector arrange(Vector midpoints) {
    Vector classes =new Vector();
    //includes indexes of taken points
    Vector index = new Vector();
    Observation o;
    int jValue;
    Observation help;
    Integer integer, integer2;
    //comparing to taken points is not made
    for (int i=0; i < midpoints.size(); i++)
    {
      integer = new Integer(i);
      if (!index.contains(integer))
      {
        jValue = i;
        o = (Observation)midpoints.elementAt(i);
        //compares taken point to other points
        for (int j=0; j<midpoints.size(); j++)
        {
          integer2 = new Integer(j);
          if (!index.contains(integer2))
          {
            help = (Observation)midpoints.elementAt(j);
            if (o.getX() < help.getX())
            {
              o = help;
              jValue =j;
              i=-1;
            }
          }
        }
        Integer help2 = new Integer(jValue);
        index.add(help2);
        classes.add(midpoints.elementAt(jValue));
      }
    }
   return classes;
  }

}