

/**
 * Title:        Membership.java
 * Description:  Class for member function value
 * Copyright:    Annemari Auvinen, Anu Niemi (c) 2002
 * Company:
 * @author       Annemari Auvinen, Anu Niemi
 * @version      1.0
 *
 * @param value  Double value of the membership function.
 */


public class Membership {
  private double value;

/**
 * Constructor for the Membership.
 * @param   value   Double value of member function
 */
  public Membership(double value) {
    this.value = value;
  }

  /**
 * Returns the value.
 * @return      Double value of member function.
 */
  public double getValue()
  {
    return value;
  }
}