

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */
import java.util.*;
import java.lang.*;
//import java.lang;

public class sumea_kmeans {
    private Vector datapisteet= new Vector();
    private Vector k_pisteet = new Vector();
    private Vector vanhat_kpisteet = new Vector();
    private Hashtable jasenyysfunktiot = new Hashtable();
    private Hashtable vanhat_jasenyysfunktiot = new Hashtable();
    private int clusters;
    private int b;
    private double epsilon;
    private double muutos;

  public sumea_kmeans(Vector datapisteet, int K, int b, double epsilon) {
    this.datapisteet = datapisteet;
    this.clusters = K;
    this.b = b;
    this.epsilon = epsilon;
  }

  public void alusta()
  {
     Random sluku = new Random();
      int lkm, luku;
     //alustetaan keskipisteet ja jsenyysfunktiot
     //jasenyysfunktiot
     lkm = datapisteet.size();
     for (int i=0; i<clusters; i++)  {
       luku  =  sluku.nextInt(lkm);
       havainto kp = (havainto)datapisteet.elementAt(luku);
       k_pisteet.add(kp);

       for (int j=0; j<lkm; j++) {
         jasenyys j1 = new jasenyys(0);
         String paikka = i+"_"+j;
         jasenyysfunktiot.put(paikka,j1);
       }
     }
    muutos = epsilon + 1; //lopetusehto
  }

  public void laske_keskipisteet()
  {
    double osoittaja_X;
    double osoittaja_Y;
    double nimittaja;
    int lkm = datapisteet.size();
    for (int l=0; l<clusters;l++) {
      havainto h1 = (havainto)k_pisteet.elementAt(l);
      vanhat_kpisteet.add(l,h1);
    }
    for (int i=0; i<clusters;i++) {
      osoittaja_X = 0;
      osoittaja_Y = 0;
      nimittaja = 0;
      for (int j=0; j<lkm;j++) {
        String paikka = i+"_"+j;
        jasenyys j1 = (jasenyys)jasenyysfunktiot.get(paikka);
        havainto h1= (havainto)datapisteet.elementAt(j);
        double  kerroin = Math.pow(j1.getArvo(),b);
        osoittaja_X +=  kerroin*h1.getX();
        osoittaja_Y += kerroin* h1.getY();
        nimittaja += kerroin;
      }
      havainto hav;
      if(nimittaja != 0) {
         hav = new havainto(osoittaja_X/nimittaja, osoittaja_Y/nimittaja);
      }
      else {
         hav = new havainto(0,0);
      }
        k_pisteet.add(i,hav);


    }
  }

  public void laske_jasenyysarvot()
  {
    int lkm,i;
    String paikka;
    double kpX, kpY,X,Y, etaisyys, osoittaja, nimittaja, potenssi;
    lkm = datapisteet.size();
    for( i=0; i<clusters;i++)
    {
      for (int l=0;l<lkm;l++) {
      paikka = i+"_"+l;
      jasenyys jasen = (jasenyys)jasenyysfunktiot.get(paikka);
      vanhat_jasenyysfunktiot.put(paikka,jasen);
     }
    }
    for( i=0; i<clusters;i++)
    {
      havainto kp = (havainto)k_pisteet.elementAt(i);
      kpX = kp.getX();
      kpY = kp.getY();
      //lasketaan osoittaja
      for( int j=0;j<lkm;j++)
      {
        havainto piste = (havainto)datapisteet.elementAt(j);
        X = piste.getX();
        Y = piste.getY();
        //etaisyys
        etaisyys = Math.pow((X-kpX),2.0)+Math.pow((Y-kpY),2.0);
        potenssi = 1.0/(b-1);
        osoittaja = Math.pow((1.0/etaisyys), potenssi);
        nimittaja = 0.0;
        //lasketaan nimittaja
        for (int k=0; k<clusters; k++)
        {
          kp = (havainto)k_pisteet.elementAt(k);
          kpX=kp.getX();
          kpY=kp.getY();
          etaisyys = Math.pow((X-kpX),2.0)+Math.pow((Y-kpY),2.0);
          nimittaja += Math.pow((1.0/etaisyys),potenssi);
        }
        jasenyys j1 = new jasenyys(osoittaja/nimittaja);
        paikka = i+"_"+j;
        jasenyysfunktiot.put(paikka,j1);
      }
    }
  }
  public void iteroi() {
    int lkm;
    String paikka;
    double jasenarvo,vanha_arvo,suurin,apu,apu2,etaisyys;
    suurin = 0.0;
    apu = 0.0;
    apu2 = 0.0;
    lkm = datapisteet.size();
    while (muutos > epsilon)
    {
    //  tulosta();
      laske_keskipisteet();
      tulosta();
      laske_jasenyysarvot();
      //lopetusehto: jasenyyden max muutos
      for(int i=0; i<clusters;i++)
      {
         havainto k_uusi = (havainto)k_pisteet.elementAt(i);
         havainto k_vanha = (havainto)vanhat_kpisteet.elementAt(i);
         etaisyys = Math.sqrt(Math.pow((k_uusi.getX()-k_vanha.getX()),2.0)+Math.pow((k_uusi.getY()-k_vanha.getY()),2.0));
         //System.out.println(etaisyys);
        for (int j=0; j<lkm; j++)
        {
          paikka = i+"_"+j;
          jasenyys j1 = (jasenyys)jasenyysfunktiot.get(paikka);
          jasenarvo = j1.getArvo();
          jasenyys j2 = (jasenyys)vanhat_jasenyysfunktiot.get(paikka);
          vanha_arvo = j2.getArvo();
          apu = Math.abs(jasenarvo-vanha_arvo);
          //System.out.println(apu);

          if(apu > suurin)
            suurin = apu;
        }
      if(etaisyys > suurin)
        suurin = etaisyys;
      }


      muutos = suurin;
      System.out.println(muutos);
    }

  }

  public void tulosta()
  {
    int lkm = datapisteet.size();
    String paikka;
    String jono;
    System.out.println("alkaa");
    for(int i=0; i<clusters;i++)

    {
      havainto k = (havainto)k_pisteet.elementAt(i);
     jono = "piste :"+k.getX()+" "+k.getY();
     System.out.println(jono);
     for (int j=0; j<lkm; j++)
      {
        paikka = i+"_"+j;
        System.out.println(paikka);
        jasenyys j1 = (jasenyys)jasenyysfunktiot.get(paikka);
     //   jasenyys j2 = (jasenyys)vanhat_jasenyysfunktiot.get(paikka);
        jono = "uusi: "+j1.getArvo();
        System.out.println(jono);
      }
    }
  }
}